'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

require('babel-polyfill');

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _vorpal = require('vorpal');

var _vorpal2 = _interopRequireDefault(_vorpal);

var _package = require('../package.json');

var _config = require('./utils/config');

var _config2 = _interopRequireDefault(_config);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var name = _config2.default.name || 'lisky'; /*
                                              * LiskHQ/lisky
                                              * Copyright © 2017 Lisk Foundation
                                              *
                                              * See the LICENSE file at the top-level directory of this distribution
                                              * for licensing information.
                                              *
                                              * Unless otherwise agreed in a custom licensing agreement with the Lisk Foundation,
                                              * no part of this software, including this file, may be copied, modified,
                                              * propagated, or distributed except according to the terms contained in the
                                              * LICENSE file.
                                              *
                                              * Removal or modification of this copyright notice is prohibited.
                                              *
                                              */

var lisky = (0, _vorpal2.default)();

var commandsDir = _path2.default.join(__dirname, 'commands');

_fs2.default.readdirSync(commandsDir).forEach(function (command) {
  var commandPath = _path2.default.join(commandsDir, command);
  // eslint-disable-next-line global-require, import/no-dynamic-require
  var commandModule = require(commandPath);
  lisky.use(commandModule.default);
});

var copyright = _chalk2.default.dim('Lisky  Copyright (C) 2017  Lisk Foundation\nThis program comes with ABSOLUTELY NO WARRANTY; for details type `show w`.\nThis is free software, and you are welcome to redistribute it under certain conditions; type `show c` for details.\n');

var logo = _chalk2.default.rgb(36, 117, 185)('\n _ _     _\n| (_)___| | ___   _\n| | / __| |/ / | | |\n| | \\__ \\   <| |_| |\n|_|_|___/_|\\_\\\\__, |\n              |___/\n');

var message = '\nRunning v' + _package.version + '.\nType `help` to get started.\n';
var intro = '' + copyright + logo + message;

lisky.delimiter(name + '>').history(name);

if (process.env.NON_INTERACTIVE_MODE !== 'true') {
  lisky.log(intro).show();
}

lisky.find('help').alias('?');
lisky.find('exit').description('Exits ' + name + '.');

exports.default = lisky;