'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.logError = exports.logWarning = exports.printResult = undefined;

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }(); /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * LiskHQ/lisky
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * Copyright © 2017 Lisk Foundation
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * See the LICENSE file at the top-level directory of this distribution
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * for licensing information.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * Unless otherwise agreed in a custom licensing agreement with the Lisk Foundation,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * no part of this software, including this file, may be copied, modified,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * propagated, or distributed except according to the terms contained in the
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * LICENSE file.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * Removal or modification of this copyright notice is prohibited.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          */


var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _stripAnsi = require('strip-ansi');

var _stripAnsi2 = _interopRequireDefault(_stripAnsi);

var _config = require('./config');

var _config2 = _interopRequireDefault(_config);

var _helpers = require('./helpers');

var _tablify = require('./tablify');

var _tablify2 = _interopRequireDefault(_tablify);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var removeAnsi = function removeAnsi(result) {
	return Object.entries(result).reduce(function (strippedResult, _ref) {
		var _ref2 = _slicedToArray(_ref, 2),
		    key = _ref2[0],
		    value = _ref2[1];

		return Object.assign({}, strippedResult, _defineProperty({}, key, (0, _stripAnsi2.default)(value)));
	}, {});
};

var printResult = exports.printResult = function printResult(vorpal) {
	var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
	return function (result) {
		var useJsonOutput = (0, _helpers.shouldUseJsonOutput)(_config2.default, options);
		var prettifyOutput = (0, _helpers.shouldUsePrettyOutput)(_config2.default, options);
		var resultToPrint = useJsonOutput ? removeAnsi(result) : result;

		var output = useJsonOutput ? JSON.stringify(resultToPrint, null, prettifyOutput ? '\t' : null) : (0, _tablify2.default)(resultToPrint).toString();

		vorpal.activeCommand.log(output);
		return resultToPrint;
	};
};

// TODO: Include commented placeholders when we support Node 8
var PLACEHOLDERS = ['%s', '%d',
// '%i',
// '%f',
'%j'];

var wrapLogFunction = function wrapLogFunction(fn, colour) {
	return function () {
		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		var colourArg = function colourArg(arg) {
			return _chalk2.default[colour](arg);
		};
		var isPlaceholderPresent = function isPlaceholderPresent(placeholder) {
			return args[0].includes(placeholder);
		};
		return PLACEHOLDERS.some(isPlaceholderPresent) ? fn.apply(undefined, [colourArg(args[0])].concat(_toConsumableArray(args.slice(1)))) : fn.apply(undefined, _toConsumableArray(args.map(colourArg)));
	};
};

var logWarning = exports.logWarning = wrapLogFunction(console.warn, 'yellow');
var logError = exports.logError = wrapLogFunction(console.error, 'red');