'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }(); /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * LiskHQ/lisky
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * Copyright © 2017 Lisk Foundation
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * See the LICENSE file at the top-level directory of this distribution
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * for licensing information.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * Unless otherwise agreed in a custom licensing agreement with the Lisk Foundation,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * no part of this software, including this file, may be copied, modified,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * propagated, or distributed except according to the terms contained in the
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * LICENSE file.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * Removal or modification of this copyright notice is prohibited.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          */


var _cliTable = require('cli-table2');

var _cliTable2 = _interopRequireDefault(_cliTable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var chars = {
	top: '═',
	'top-mid': '╤',
	'top-left': '╔',
	'top-right': '╗',
	bottom: '═',
	'bottom-mid': '╧',
	'bottom-left': '╚',
	'bottom-right': '╝',
	left: '║',
	'left-mid': '╟',
	mid: '─',
	'mid-mid': '┼',
	right: '║',
	'right-mid': '╢',
	middle: '│'
};

var getNestedValue = function getNestedValue(data) {
	return function (keyString) {
		return keyString.split('.').reduce(function (obj, key) {
			return obj[key];
		}, data);
	};
};

var addValuesToTable = function addValuesToTable(table, data) {
	var nestedValues = table.options.head.map(getNestedValue(data));
	var valuesToPush = nestedValues.map(function (value) {
		return Array.isArray(value) ? value.join('\n') : value;
	});
	return valuesToPush.length && table.push(valuesToPush);
};

var reduceKeys = function reduceKeys(keys, row) {
	var newKeys = Object.keys(row).filter(function (key) {
		return !keys.includes(key) && row[key] !== undefined && !(row[key] instanceof Error);
	});
	return keys.concat(newKeys);
};

var getKeys = function getKeys(data) {
	return Object.entries(data).map(function (_ref) {
		var _ref2 = _slicedToArray(_ref, 2),
		    parentKey = _ref2[0],
		    value = _ref2[1];

		return Object.prototype.toString.call(value) === '[object Object]' ? getKeys(value).reduce(function (nestedKeys, childKey) {
			return [].concat(_toConsumableArray(nestedKeys), [parentKey + '.' + childKey]);
		}, []) : [parentKey];
	}).reduce(function (flattenedKeys, keysToBeFlattened) {
		return [].concat(_toConsumableArray(flattenedKeys), _toConsumableArray(keysToBeFlattened));
	}, []);
};

var tablify = function tablify(data) {
	var dataIsArray = Array.isArray(data);
	var head = dataIsArray ? data.reduce(reduceKeys, []) : getKeys(data);

	var table = new _cliTable2.default({
		head: head,
		chars: chars,
		style: {
			head: ['cyan'],
			border: []
		}
	});

	if (dataIsArray) {
		data.map(addValuesToTable.bind(null, table));
	} else {
		addValuesToTable(table, data);
	}

	return table;
};

exports.default = tablify;